unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
   TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText10: TStaticText;
    EditAlfa: TEdit;
    EditBeta: TEdit;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditR1: TEdit;
    EditR2: TEdit;
    EditS1: TEdit;
    EditS2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    EditRovX: TEdit;
    EditRovY: TEdit;
    EditRovZ: TEdit;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    EditD: TEdit;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    EditAlfaLight: TEdit;
    EditBetaLight: TEdit;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph3D_2005;
Type TSegment = record A,B,C,D:T3DPoint;
                       Dist   :Double;
                end;
var Segment   :array [0..50000] of TSegment;

{$R *.DFM}
procedure TControl_Panel.Plocha(Sender: TObject);

const RightRed=255;RightGreen=188;RightBlue=112;
      WrongRed=143;WrongGreen=235;WrongBlue=255;
      Right=True;Wrong=False;
var Code,i,j     :Integer;
    fx,fy,fz,
    ErrorReport :String;
    Alfa,Beta   :Double;
    Condition   :Boolean;
    Direct,Distance,Min,Max:Double;
    Surf1,Surf2 :Boolean;
    u,v,w       :TVector;
    Express_fx,
    Express_fy,
    Express_fz  :TExpression;

  Procedure Setting;
  var numer:Real;
  begin
    Val(EditX1.Text,Numer,Code);Draw3D.X1:=Numer;
    Val(EditX2.Text,Numer,Code);Draw3D.X2:=Numer;
    Val(EditY1.Text,Numer,Code);Draw3D.Y1:=Numer;
    Val(EditY2.Text,Numer,Code);Draw3D.Y2:=Numer;
    Val(EditR1.Text,Numer,Code);Draw3D.R1:=Numer;
    Val(EditR2.Text,Numer,Code);Draw3D.R2:=Numer;
    Val(EditS1.Text,Numer,Code);Draw3D.S1:=Numer;
    Val(EditS2.Text,Numer,Code);Draw3D.S2:=Numer;
    fx:=EditRovX.Text;
    fy:=EditRovY.Text;
    fz:=EditRovZ.Text;
    Val(EditAlfa.Text,Alfa,Code);
    Val(EditBeta.Text,Beta,Code);
    Val(EditAlfaLight.Text,Draw3D.AlfaLight,Code);
    Val(EditBetaLight.Text,Draw3D.BetaLight,Code);
    Val(EditD.Text,Draw3D.ObserverDistance,Code);
  end;

   procedure sort(Left,Right:LongInt);
   var i,j      :LongInt;
       Pivot    :Double;
       Trezor   :TSegment;
   begin
     i:=Left;j:=Right;
     pivot:=Segment[(Left+Right) div 2].Dist;
     repeat
     while Segment[i].Dist<pivot do inc(i);
     while Segment[j].Dist>pivot do dec(j);
     if i<=j then
              begin
                Trezor:=Segment[i];Segment[i]:=Segment[j];Segment[j]:=Trezor;
                inc(i);dec(j);
              end;
   until i>j;
   if Left<j then sort(Left,j);
   if Right>i then sort(i,Right);
   end;

  begin
    Setting;
    With Draw3D do
    begin
    Visible:=True;ClearImage(255,255,230);
    Scale(x1,x2,y1,y2);
    SetCenterProjection(Alfa,Beta,ObserverDistance,ObserverPoint);
    SetDirectOfLight(AlfaLight,BetaLight,DirectOfLight);
    hr:=(r2-r1)/80;hs:=(s2-s1)/20;
    Express_fx:=PreCalc(fx,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fy:=PreCalc(fy,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fz:=PreCalc(fz,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    r:=r1;j:=0;
    Repeat
      s:=s1;
      Repeat
         Segment[j].A[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].A[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].A[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].Dist:=sqr(ObserverPoint[1]-Segment[j].A[1])
                         +sqr(ObserverPoint[2]-Segment[j].A[2])
                         +sqr(ObserverPoint[3]-Segment[j].A[3]);
         s:=s+hs;
         Segment[j].B[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].B[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].B[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         r:=r+hr;
         Segment[j].C[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].C[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].C[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         s:=s-hs;
         Segment[j].D[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].D[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[j].D[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         inc(j);
         r:=r-hr;
         s:=s+hs;
       until s>s2;
      r:=r+hr;
    until r>r2;
    dec(j);
    Sort(0,j);
    For i:=j downto 0 do
    begin
      SetVector(Segment[i].B,Segment[i].C,u);SetVector(Segment[i].B,Segment[i].A,v);
      VectorProduct(u,v,w);
      SetVector(Segment[i].B,ObserverPoint,u);
      Direct:=CosAngle(u,w);
         if Direct>0
               then begin Red:=WrongRed;Green:=WrongGreen;Blue:=WrongBlue;end
               else begin Red:=RightRed;Green:=RightGreen;Blue:=RightBlue;end;
         Direct:=CosAngle(DirectOfLight,w);
        if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     Red:=Trunc(abs(Direct)*Red);
                     Green:=Trunc(abs(Direct)*Green);
                     Blue:=Trunc(abs(Direct)*Blue);
                    end
               else begin Red:=0;Green:=0;Blue:=0;end;
         FillTriangle(Segment[i].A,Segment[i].B,Segment[i].C,Red,Green,Blue);
         FillTriangle(Segment[i].C,Segment[i].D,Segment[i].A,Red,Green,Blue);
        if i mod 100 = 0 then Image.Repaint;
      end;
 end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;
procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Real;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;


procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
   Application.CreateForm(TDraw3D, Draw3D);
  With Draw3D do
  begin
    Image.align:=alNone;
    ClientWidth:=500;ClientHeight:=500;
    InitImage(500,500);
    Top:=40;Left:=400;
    Caption:='Param Plane - Constant Shading';
    Visible:=True;
  end;
end;



end.
